<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Logs
  {

   function __construct() { }

   public static function getLogFieldsArray()
    {
     return array('logID','referer','ip','dns','userID','adminID','ts');
    }

   public static function writeLog($w3)
    {
	 $_FIELD = webmatic3::getPostValueArray(wm3Logs::getLogFieldsArray(),WM3_cQUOTE_DB);
	 $_FIELD['referer'] = getenv('HTTP_REFERER');
     $_FIELD['ip']      = getenv('REMOTE_ADDR');
     $_FIELD['dns']     = gethostbyaddr($_FIELD['ip']);
     $_FIELD['userID']  = $w3->getAuthenticateUserID();
     $_FIELD['adminID'] = $w3->getAuthenticateAdminID();
     $_FIELD['ts']      = time();
     wm3Sql::saveAllTableFields('_logs',$_FIELD);
    }

   public static function getLogList($w3,$currentID = 0,$admin = true)
    {
     // Get messages list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 65;
     $pg = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE referer LIKE '%$filter%'
	                       OR dns     LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ""; }
     $search_form_link = WM3_cCONFIG_ADMIN_FILE;
     $columns = 5; $buttons = 1;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_logs.ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_logs
                        $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'messageID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0 && $admin) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array(); $search_form = "";
     if($admin)
      {
       $_SEP = $w3->getSkinObj()->getSeparator();
       require(WM3_cPATH_INCLUDE."admin_log_search_form.inc");
       array_push($_CONTENTS,$w3->getWord(1248)." $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_DELETE_ALL_LOG,"action_delete_mini.png","",$w3->getWord(1256),$w3->getWord(1255),0,16,16));
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array(10,8,36,46,0),array(228,1671,228,228),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array(8,14,32,46);
       $link = $base_link.$id_link.$extra_link."&logID=$row->logID";
	   $date = wm3Util::renderDate($w3,$row->ts,$w3->getAdminLanguage());
	   $ip = "<b>".$row->ip."</b><br>";
	   if($row->userID  == WM3_cUSER_ANONYMOUS) $user_login  = $w3->getWord(988); else $user_login  = wm3User::getUserLogin($row->userID);
	   if($row->adminID == WM3_cUSER_ANONYMOUS) $admin_login = "";                else $admin_login = wm3User::getUserLogin($row->adminID);
	   $ip .= "User $user_login"; if($admin_login) $ip .= "<br>Admin $admin_login";
	   $referer = "<a href=\"$row->referer\">$row->referer</a>";
       array_push($_CONTENTS,$date,$ip,$row->dns,$referer);
       // Buttons
       array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_LOG,"action_delete.png",$w3->getWord(179),$w3->getWord(774)));
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->logID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
	   if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$id_link.$search_link."&action=".WM3_cACTION_SHOW_LOG);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function deleteLog($logID)
    {
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_logs WHERE logID = '$logID'");
	}

   public static function deleteLogAll()
    {
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_logs");
	}

  }

?>
