<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Sql
  {

   function __construct() {}

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_RESTORE_DATABASE:
        {
         return 'Not implemented jet';//wm3Sql::xxx($w3); // TODO
         break;
        }
       case WM3_cACTION_SAVE_BACKUP_DATABASE:
        {
		 return wm3Sql::backupDatabase($w3,true);
		}
       default:
        {
         return wm3Sql::backupDatabase($w3);
        }
      }     
    }

   public static function backupDatabase($w3,$save = false)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(array('target'));
     $_FIELD = webmatic3::getPostValueArray(array('target'));

     if($save) // Save database backup
      {
       $ts = time(); $date = date("m-d-Y",$ts); $time = date("(H.i.s)",$ts);
       $backup_header = "-- Database: ".WM3_cCONFIG_DB_NAME."\n".
                        "-- Backup date: $date $time\n\n";
       $backup = wm3Util::quoteHTML(wm3Sql::backupDB());
       if($_FIELD['target'] == WM3_cDATABASE_TARGET_FILE)
        {
         $filename  = WM3_cCONFIG_DB_NAME."_".$date.$time.".sql";
         $mime_type = "text/plain";
         header("Content-type: $mime_type"); 
         header("Content-Disposition: attachment; filename=$filename");
         echo $backup_header.$backup;
         die;         
		}
       if($_FIELD['target'] == WM3_cDATABASE_TARGET_VIDEO)
        {
         $_CONTENTS = array(); $columns = 2;
         array_push($_CONTENTS,$w3->getWord(1761));
         $backup_dump = "<br>".wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

         // Create list items
         $_WIDTHS   = array(20,80);
         $_CONTENTS = array(wm3Util::inputTextArea('backup',$backup_header.$backup,22,125));
         $button    = "<input type=\"button\" name=\"select_all\" value=\"".$w3->getWord(1308)."\" onClick=\"wm3_selectAll('backup');\">";
	     array_push($_CONTENTS,$button);
         $backup_dump .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false);

         // Create list bottom
         $backup_dump .= wm3Section::makeBottomList($w3,$columns);
         return $backup_dump;
		}
	  }

     $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
     $form_title          = $w3->getWord(1761);
     $next_action         = WM3_cACTION_SAVE_BACKUP_DATABASE;
     $next_action_label   = $w3->getWord(1762);
     require(WM3_cPATH_INCLUDE."admin_database_backup_form.inc");
     return $content;
    }

   private function DBConnect()
    {
     // Connect to the database (die if fail)
     $con = @mysql_connect(WM3_cCONFIG_DB_SERVER,WM3_cCONFIG_DB_USER,WM3_cCONFIG_DB_PASSWORD)
      or wm3Util::dieMessage("MySQL error","Can not connect to the MySql database server ".WM3_cCONFIG_DB_SERVER);
     mysql_select_db(WM3_cCONFIG_DB_NAME,$con)
	  or wm3Util::dieMessage("MySQL error","Can not select the database ".WM3_cCONFIG_DB_NAME);
     return $con;
    }

   public static function sqlQuery($query)
    {
     // Connect to the database and do the $query (die if fail)
     global $WM3_cQUERY_AFFECTED;

     $WM3_cQUERY_AFFECTED++;
     $rs = mysql_query($query,self::DBConnect())
	  or wm3Util::dieMessage("MySQL error","Can not execute the query:<br><b>$query</b>");
     return $rs;
    }

   public static function saveAllTableFields($tb,$_F,$_R = array(),$id = true)
    {
     // Insert all fields in a table filled with values ($_F its an array with fields/values)
     // The field in the $_R array (remove array) will not performed
	 // if $id its true the first field in $_F will be processed as an autoincrement key
     $n = 0;
     $part1 = $part2 = "";
     while(list($k,$v) = each($_F))
      {
       $use = 1;
       for($j = 0; $j < sizeof($_R); $j++) if($k == $_R[$j]) $use = 0;
       if($use)
        {
         if($n == 0) {
			          if($id) { $part1 .= $k; $part2 .= "''";       }
					  else    { $part1 .= $k; $part2 .= "'".$v."'"; }
					 }
         else        { $part1 .= ", ".$k; $part2 .= ", '".$v."'"; }
         $n++;
        }
      }
     $query = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."$tb (".$part1.") VALUES (".$part2.")";
     wm3Sql::sqlQuery($query);
    }

   public static function countTable($table,$where = "")
    {
     $row = mysql_fetch_object(wm3Sql::sqlQuery("SELECT COUNT(*) AS total FROM $table $where"));
     return $row->total;
    }

   public static function getFirstRowField($table,$field)
    {
	 $rs = wm3Sql::sqlQuery("SELECT $field FROM $table LIMIT 0,1");
     if(mysql_num_rows($rs) == 1)
	  {
	   $row = mysql_fetch_array($rs);
	   return $row[$field];
	  }
	 return "";
    }

   public static function getLastInsertID()
    {
     $row = mysql_fetch_array(wm3Sql::sqlQuery("SELECT LAST_INSERT_ID()"));
     return $row[0];
    }

   public static function getNextAutoIncrementID($table)
    {
     $row = mysql_fetch_array(wm3Sql::sqlQuery("SHOW TABLE STATUS LIKE '$table'"));
     return $row['Auto_increment'];
    }

   public static function checkConnection($server,$user,$password,$name)
    {
     $con = @mysql_connect($server,$user,$password);
     return @mysql_select_db($name,$con);
    }

   public static function checkDatabaseServerVersion($server,$user,$password)
    {
     $con = @mysql_connect($server,$user,$password); if(!$con) return 0;
	 if(!(floatval(mysql_get_server_info($con)) >= 4.1)) return 0;
     else return 1;
    }

   public static function getRSPosition($rs,$field,$id_value)
    {
	 $i = 0;
	 while($row = mysql_fetch_array($rs))
	  {
	   if($row[$field] == $id_value) return $i;
	   $i++;
	  }
     return;
    }

   public static function existValue($table,$field,$value,$id_name = "",$id_value = 0)
    {
	 $query = "SELECT $field FROM $table WHERE $field = '$value'";
	 if($id_name) $query .= " AND $id_name <> '$id_value'";
	 $rs = wm3Sql::sqlQuery($query);
     if(mysql_num_rows($rs) != 0) return true;
	 return false;
    }

   public static function existsDatabase()
    {
     $con = wm3Sql::DBConnect();
	 //return @mysql_query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_wcm",$con);

	 //TODO verificare bene...
	 return @mysql_query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_wcm",$con) || 
	        @mysql_query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_database",$con);
    }

   public static function existsTable($table)
    {
	 $rs = wm3Sql::sqlQuery("SHOW TABLES LIKE '$table'");
     if(mysql_num_rows($rs) == 0) return false;
     else                         return true;
	}

   public static function countDBTables()
    {
	 // Return the number of total tables in the database
	 $rs = wm3Sql::sqlQuery("SHOW TABLES LIKE '".WM3_cCONFIG_DB_PREFIX."%'");
	 return mysql_num_rows($rs);
	}

   public static function countDBUsedSpace($w3)
    {
	 // Return the number of total bytes used by database
	 $bytes = 0;
	 $rs = wm3Sql::sqlQuery("SHOW TABLE STATUS LIKE '".WM3_cCONFIG_DB_PREFIX."_%'");
     while($row = mysql_fetch_array($rs))
      {
	   $bytes += $row['Data_length'] + $row['Index_length'];
      }
     return $bytes;
	}

   public static function getDBVersion()
    {
	 if(wm3Sql::existsTable(WM3_cCONFIG_DB_PREFIX."_wcm"))
	  {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_wcm");
       if(mysql_num_rows($rs) == 1)
	    {
	     $row = mysql_fetch_object($rs);
         return $row->wcm;
	    }
	   else return 1.0; // Database version 1.0
      }
	 if(wm3Sql::existsTable(WM3_cCONFIG_DB_PREFIX."_database"))
	  {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_database");
       $row = mysql_fetch_object($rs);
       return $row->database_version;
      }
	 return 0; // Database non installed or incorrect installation
    }

   private function backupDB()
    {
	 // Create a database backup in Sql format
     $str         = '';
     $table_rs    = mysql_list_tables(WM3_cCONFIG_DB_NAME,wm3Sql::DBConnect());
     $table_total = mysql_num_rows($table_rs);
     for($j = 0; $j < $table_total; $j++)
      {
       $table_name = mysql_tablename($table_rs,$j);
       //TODO Parse only table that name start with WM3_cCONFIG_DB_PREFIX ???
       //if($table_name == WM3_cCONFIG_DB_PREFIX) //TODO
       {
		// Create database table structure
        $field_rs    = mysql_list_fields(WM3_cCONFIG_DB_NAME,$table_name,wm3Sql::DBConnect());
        $field_total = mysql_num_fields($field_rs);
        $str .= "CREATE TABLE $table_name\n (";
        for($i = 0; $i < $field_total; $i++)
         {
          $field_name  = mysql_field_name ($field_rs,$i);
          $field_type  = mysql_field_type ($field_rs,$i);
          $field_len   = mysql_field_len  ($field_rs,$i);
          $field_flags = mysql_field_flags($field_rs,$i);

          // Keep only unsigned, primary key and auto_increment flags //(TODO ne mancano altri???)
          $flags = '';
          if(stristr($field_flags, "unsigned"      ) != '') $flags .= " unsigned";
          if(stristr($field_flags, "primary_key"   ) != '') $flags .= " primary key";
          if(stristr($field_flags, "auto_increment") != '') $flags .= " auto_increment";

          if($field_type == "string") $field_type = "char";
          if($field_type == "date" || $field_type =="time") $str .= "\n  $field_name $field_type$flags";
          else                                              $str .= "\n  $field_name $field_type($field_len)$flags";
          if($i != $field_total - 1) $str .= ",";        
         }
        $str .= "\n );";

        // Create database table content
        $rs = wm3Sql::sqlQuery("SELECT * FROM ".$table_name);
        while($row = mysql_fetch_array($rs))
         {
          $str .= "\nINSERT INTO $table_name VALUES (";
          for($i = 0; $i < $field_total; $i++)
           {
            $str .= "  ".mysql_field_name($field_rs,$i)."='$row[$i]'";
            if($field_total > 1 && $i == $field_total - 1) $str .= "\n"; else $str .= ", ";
           }
          $str .= ");\n";
         }
        if($j != $table_total - 1) $str .= "\n\n";
       }
     }
    return $str;
   }

  }

?>
