<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Statistic
  {

   function __construct() { }

   public static function getStatisticHistoryFieldsArray()
    {
     return array('historyID','year','day','month','hour','day_of_the_week','hits','ts');
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       /*case WM3_cACTION_SAVE_FAQ_CATEGORY:
        {
         $error = wm3Faq::checkFaqCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3Faq::saveFaqCategory($w3);
           // $msg= message saved... //TODO
           return wm3Faq::getFaqCategoryList($w3,$lastID);
          }
         else return wm3Faq::addFaqCategory($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_FAQ_CATEGORY:
        {
         return wm3Faq::editFaqCategory($w3);
         break;
        }
       case WM3_cACTION_DISABLE_FAQ_CATEGORY:
        {
         wm3Faq::disableFaqCategory($w3->getVariable('categoryID','get'));
         return wm3Faq::getFaqCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }*/
       case WM3_cACTION_DELETE_LOG:
        {
         wm3Logs::deleteLog($w3->getVariable('logID','get'));
		 return wm3Logs::getLogList($w3);
         break;
        }
       case WM3_cACTION_DELETE_ALL_LOG:
        {
         wm3Logs::deleteLogAll();
		 return wm3Logs::getLogList($w3);
         break;
        }
       case WM3_cACTION_SHOW_LOG:
        {
         return wm3Logs::getLogList($w3);
         break;
        }
	   case WM3_cACTION_RESET_ALL_STATISTIC:
	    {
		 wm3Statistic::resetStatisticAll();
		 return wm3Statistic::getStatisticBase($w3);
		 break;
		}
       case WM3_cACTION_SHOW_TREND_STATISTIC:
        {
         return wm3Statistic::getStatisticTrend($w3);
         break;
        }
       case WM3_cACTION_RENDER_TREND_STATISTIC:
        {
         $error = wm3Statistic::checkStatisticTrendError($w3);
         if(!$error)
          {
           return wm3Statistic::getStatisticTrend($w3,false);
          }
         else return wm3Statistic::getStatisticTrend($w3,false,$error);
         break;
        }
       case WM3_cACTION_SHOW_HISTORY_STATISTIC:
        {
         return wm3Statistic::getStatisticHistory($w3);
         break;
        }
       default:
        {
         return wm3Statistic::getStatisticBase($w3);
        }
      }
    }

   public static function executeWebmaticInformationAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_SHOW_PHP_INFORMATIONS:
        {
         return wm3Util::getPhpInformations();
         break;
        }
       default:
        {
         return wm3Statistic::getWebmaticInformations($w3);
        }
      }
    }

   public static function checkStatisticTrendError($w3)
    {
     // Check form invalid inputs
     $start_day = $w3->getVariable('start_day','post'); $start_month = $w3->getVariable('start_month','post'); $start_year = $w3->getVariable('start_year','post'); $start_hour = $w3->getVariable('start_hour','post');
     $end_day   = $w3->getVariable('end_day','post');   $end_month   = $w3->getVariable('end_month','post');   $end_year   = $w3->getVariable('end_year','post');   $end_hour   = $w3->getVariable('end_hour','post');
     $step      = $w3->getVariable('step','post');      $zoom        = $w3->getVariable('zoom','post');
     if(!$start_day) return 1;
     return 0;
    }

   public static function getStatisticBase($w3)
    {
     // Base statistics page content (home and admin side)

     $str =  wm3Statistic::renderStatisticBase($w3,"_statistics_oses",765)."<br><br>";
     $str .= wm3Statistic::renderStatisticBase($w3,"_statistics_browsers",766)."<br><br>";
     $str .= wm3Statistic::renderStatisticBase($w3,"_countries",809,15,true)."<br><br>";
	 $str .= wm3Statistic::renderStatisticBasePage($w3,814,10)."<br><br>";
	 $str .= wm3Statistic::renderStatisticBaseNews($w3,815,10)."<br><br>";
	 $str .= wm3Statistic::renderStatisticBaseDownload($w3,1092,10)."<br><br>";
	 $str .= wm3Statistic::renderStatisticBaseMiscellaneous($w3,834);
     return $str;
    }

   public static function getStatisticHistory($w3)
    {
	 // History statistics

     $yearID  = $w3->getVariable('yearID', 'get');
	 $monthID = $w3->getVariable('monthID','get');
	 $dayID   = $w3->getVariable('dayID',  'get');
	 if(!$yearID && !$monthID && !$dayID)
	  {
       $ts = time(); $yearID = date('Y',$ts); $monthID = date('n',$ts); $dayID = date('j',$ts);
	   $str  = wm3Statistic::renderStatisticHistory($w3,938, WM3_cSTATISTIC_YEARLY                                    )."<br><br>";
	   $str .= wm3Statistic::renderStatisticHistory($w3,940, WM3_cSTATISTIC_MONTHLY,      $yearID                     )."<br><br>";
	   $str .= wm3Statistic::renderStatisticHistory($w3,941, WM3_cSTATISTIC_DAILY,        $yearID,$monthID            )."<br><br>";
	   $str .= wm3Statistic::renderStatisticHistory($w3,942, WM3_cSTATISTIC_HOURLY,       $yearID,$monthID,$dayID,true)."<br><br>";
	   $str .= wm3Statistic::renderStatisticHistory($w3,1023,WM3_cSTATISTIC_WEEKLY,            '',      '',    '',true)."<br><br>";
	   $str .= wm3Statistic::renderStatisticHistory($w3,1079,WM3_cSTATISTIC_HOURLY_GLOBAL,     '',      '',    '',true)."<br><br>";

       // Maximum visitors values
	   $total_hits = wm3Statistic::getTotalVisits();

       // Create list header
       $str .= wm3Section::makeHeaderList($w3,array($w3->getWord(964)),2);

       // Create list items
	   $_WIDTHS = array(40,60);

       // Total visitors
       $today_visits = wm3Statistic::getTodayVisits();

       // Max month
       $row = mysql_fetch_object(wm3Sql::sqlQuery("SELECT DISTINCT year, month, SUM(hits) AS hits FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history GROUP BY year, month ORDER BY hits DESC LIMIT 1"));
	   if(!$total_hits) $max_month = "---";
	   else             {
		                 $percentage = $row->hits/$total_hits*100;
	                     $ts        = mktime(0,0,0,$row->month,1,$row->year);
	                     $month     = $w3->getWordMonth(date('n',$ts));
	                     $max_month = "$month $row->year - $percentage% (".$row->hits.")";
                        }

       // Max day
       $row = mysql_fetch_object(wm3Sql::sqlQuery("SELECT DISTINCT year, month, day, SUM(hits) AS hits FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history GROUP BY year, month, day ORDER BY hits DESC LIMIT 1"));
	   if(!$total_hits) $max_day = "---";
	   else             {
		                 $percentage = $row->hits/$total_hits*100;
	                     $ts      = mktime(0,0,0,$row->month,$row->day,$row->year);
	                     $day     = wm3Util::renderDate($w3,$ts,$w3->getAdminLanguage(),true,'',false,true);
	                     $max_day = "$day - $percentage% (".$row->hits.")";
                        }

       // Max hour
       $row = mysql_fetch_object(wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history WHERE hits = (SELECT MAX(hits) AS max FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history)"));
	   if(!$total_hits) $max_hour = "---";
	   else             {
		                 $percentage = $row->hits/$total_hits*100;
	                     $ts       = mktime($row->hour,0,0,$row->month,$row->day,$row->year);
	                     $date     = wm3Util::renderDate($w3,$ts,$w3->getAdminLanguage(),true,'',false,true);
	                     $hour     = date('H',$ts);
	                     $max_hour = "$hour:00:00-$hour:59:59 [$date] - $percentage% (".$row->hits.")";
					    }

	   // Daily average
       $row = mysql_fetch_object(wm3Sql::sqlQuery("SELECT DISTINCT year, month, day FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history GROUP BY year, month, day ORDER BY year, month, day LIMIT 1"));
	   if(!$total_hits) $average = 0;
	   else             {
                         $end_ts     = time();
                         $start_ts   = mktime(0,0,0,$row->month,$row->day,$row->year);
                         $total_days = intval(($end_ts - $start_ts) / 86400) + 1;
						 $average = $total_hits / $total_days;
                        }
	   $average_day = "$average ".$w3->getWord(1021);

       // Max visitors/Users
       $max_visitors = wm3Statistic::getCounterMaxVisitors();
	   $max_users    = wm3Statistic::getCounterMaxUsers();
       $max_visitors_users = "<img src=\"".WM3_cPATH_DATA."misc_visitor.png\" width=\"16\" height=\"16\"> = $max_visitors<br><img src=\"".WM3_cPATH_DATA."misc_user.png\" width=\"16\" height=\"16\"> = $max_users";

       // Last connected user informations
	   $last_user_login = wm3User::getUserLogin(wm3Statistic::getCounterLastUserID()); if(!$last_user_login) $last_user_login = $w3->getWord(988);
       $last_user = "<b>IP:</b> ".wm3Statistic::getCounterLastUserIp()." (".wm3Statistic::getCounterLastUserDns().")<br>
	                 <b>".$w3->getWord(1099)."</b> $last_user_login<br>
					 <b>".$w3->getWord(1100)."</b> ".wm3Util::renderDate($w3,wm3Statistic::getCounterLastUserTs(),$w3->getAdminLanguage(),true,'',true,true);

       $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,array($w3->getWord(-1)."Total visitors:",  "$total_hits ($today_visits today)"),false);
	   $str .= wm3Section::makeItemList($w3,1,$_WIDTHS,array($w3->getWord(965), $max_month)                         ,false);
	   $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,array($w3->getWord(966), $max_day)                           ,false);
	   $str .= wm3Section::makeItemList($w3,1,$_WIDTHS,array($w3->getWord(967), $max_hour)                          ,false);
	   $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,array($w3->getWord(1290),$average_day)                       ,false);
	   $str .= wm3Section::makeItemList($w3,1,$_WIDTHS,array($w3->getWord(1020),$max_visitors_users)                ,false);
	   $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,array($w3->getWord(1080),$last_user)                         ,false);
      }
     else
	  {
	   if($yearID && !$monthID && !$dayID) // Yearly statistics (12 months)
	    $str = wm3Statistic::renderStatisticHistory($w3,940,WM3_cSTATISTIC_MONTHLY,$yearID);
	   if($yearID && $monthID && !$dayID)  // Monthly statistics (from 28 to 31 days)
	    $str = wm3Statistic::renderStatisticHistory($w3,941,WM3_cSTATISTIC_DAILY,$yearID,$monthID);
	   if($yearID && $monthID && $dayID)   // Daily statistics (24 hours)
	    $str = wm3Statistic::renderStatisticHistory($w3,942,WM3_cSTATISTIC_HOURLY,$yearID,$monthID,$dayID);
      }
     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,2);

	 return $str;
	}

   public static function getStatisticTrend($w3,$default = true,$error = 0)
    {
	 // Trend statistics
     $start_day = $w3->getVariable('start_day','post'); $start_month = $w3->getVariable('start_month','post'); $start_year = $w3->getVariable('start_year','post'); $start_hour = $w3->getVariable('start_hour','post');
     $end_day   = $w3->getVariable('end_day','post');   $end_month   = $w3->getVariable('end_month','post');   $end_year   = $w3->getVariable('end_year','post');   $end_hour   = $w3->getVariable('end_hour','post');
     $step      = $w3->getVariable('step','post');      $zoom        = $w3->getVariable('zoom','post');
	 $start_ts = mktime($start_hour,0,0,$start_month,$start_day,$start_year);
	 $end_ts   = mktime($end_hour,59,59,$end_month,$end_day,$end_year);
     switch($error)
      {
       case 1: // Bad date...???
        {
         $title = $w3->getWord(367);
		 $style = WM3_cSKIN_ERROR;//Verificare
         break;
        }
       default:
        {
         // Default values for the form
		 if($default)
		  {
		   $ts = time(); 
           $start_ts = $ts - 604800; $start_day = date("d",$start_ts); $start_month = date("m",$start_ts); $start_year = date("o",$start_ts); $start_hour = date("G",$start_ts);
		   $end_ts   = $ts;          $end_day   = date("d",$end_ts);   $end_month   = date("m",$end_ts);   $end_year   = date("o",$end_ts);   $end_hour   = date("G",$end_ts);
           $step = 1; $zoom = 2;
		  }
		 $start_date = wm3Util::renderDate($w3,$start_ts,$w3->getAdminLanguage());
		 $end_date   = wm3Util::renderDate($w3,$end_ts,$w3->getAdminLanguage());
         $title = "<b>".$w3->getWord(946)." $start_date ".$w3->getWord(947)." $end_date</b>";
		 $style = WM3_cSKIN_NO_ERROR;
       	}
      }
	 $str = wm3Statistic::renderStatisticTrend($w3,946,$title,$start_day,$start_month,$start_year,$start_hour,$end_day,$end_month,$end_year,$end_hour,$step,$zoom);
	 return $str;
	}

   public static function renderStatisticBase($w3,$table,$label,$max_items=0,$is_flag=false)
    {
     // Get base browsers/OSes/countries statistics list

     // Prepare variables to create the list
     $columns = 2;

     // Do the query and take the total items number
     $row = mysql_fetch_object(wm3Sql::sqlQuery("SELECT SUM(hits) AS total_hits
                                                 FROM ".WM3_cCONFIG_DB_PREFIX."$table"));
     $total_hits = $row->total_hits;
     if($max_items) $limit = "LIMIT 0,$max_items"; else $limit = "";
     $rs = wm3Sql::sqlQuery("SELECT *
                             FROM   ".WM3_cCONFIG_DB_PREFIX."$table
                             ORDER BY hits DESC
                             $limit");
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array();
     array_push($_CONTENTS,$w3->getWord($label));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       if($is_flag) { $icon = WM3_cPATH_FLAGS.$row->code.".gif"; $w = 20; $h = 13; }
       else         { $icon = WM3_cPATH_DATA.$row->icon;         $w = 36; $h = 36; }
       $hits = $row->hits;
       if(!$total_hits) $percentage = 0; else $percentage = $hits/$total_hits*100;
       array_push($_CONTENTS,"<nobr><img src=\"$icon\" border=\"0\" align=\"absmiddle\" width=\"$w\" height=\"$h\"> $row->name</nobr>");
       array_push($_CONTENTS,wm3Util::makePercentageBar($w3,$percentage,300,14)." ".round($percentage,2)."% ($hits)");
       array_push($_WIDTHS,0,100);
	   $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false,array(),false,false,true);
       $p++;
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public static function renderStatisticBasePage($w3,$label,$max_items=0)
    {
     // Get base pages statistics list

     // Prepare variables to create the list
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES); // Used to enable admin buttons
	 if($allowed) {
		           $columns = 3;
				   $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_PAGES;
				  }
	 else         { $columns = 2; }

     // Do the query and take the total items number
	 $where = "WHERE enabled = '".WM3_cENABLED."'";
     $row = mysql_fetch_object(wm3Sql::sqlQuery("SELECT SUM(hits) AS total_hits
                                                 FROM ".WM3_cCONFIG_DB_PREFIX."_pages
												 $where"));
     $total_hits = $row->total_hits;
     if($max_items) $limit = "LIMIT 0,$max_items"; else $limit = "";
     $rs = wm3Sql::sqlQuery("SELECT *
                             FROM   ".WM3_cCONFIG_DB_PREFIX."_pages
							 $where
                             ORDER BY hits DESC
                             $limit");
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array();
     array_push($_CONTENTS,$w3->getWord($label));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
	 if($allowed) $_WIDTHS = array(0,100,0); else $_WIDTHS = array(0,100);
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); 
       $hits = $row->hits;
       if(!$total_hits) $percentage = 0; else $percentage = $hits/$total_hits*100;
       $link = wm3Page::makePageLink($row->pageID,$row->title);
	   if($allowed) $allowed_link = $base_allowed_link."&pageID=$row->pageID";
       array_push($_CONTENTS,"<nobr>$link</nobr>");
       array_push($_CONTENTS,wm3Util::makePercentageBar($w3,$percentage,300,14)." ".round($percentage,2)."% ($hits)");
	   if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_PAGE,"action_edit.png",$w3->getWord(178)));
	   $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false,array(),false,false,true);
       $p++;
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public static function renderStatisticBaseNews($w3,$label,$max_items=0)
    {
     // Get base news statistics list

     // Prepare variables to create the list
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWS); // Used to enable admin buttons
	 if($allowed) {
		           $columns = 3;
				   $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_NEWS;
				  }
	 else         { $columns = 2; }

     // Do the query and take the total items number
	 $where = "WHERE enabled='".WM3_cENABLED."'";
     $row = mysql_fetch_object(wm3Sql::sqlQuery("SELECT SUM(hits) AS total_hits
                                                 FROM ".WM3_cCONFIG_DB_PREFIX."_news
												 $where"));
     $total_hits = $row->total_hits;
     if($max_items) $limit = "LIMIT 0,$max_items"; else $limit = "";
     $rs = wm3Sql::sqlQuery("SELECT *
                             FROM   ".WM3_cCONFIG_DB_PREFIX."_news
							 $where
                             ORDER BY hits DESC
                             $limit");
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array();
     array_push($_CONTENTS,$w3->getWord($label));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
	 if($allowed) $_WIDTHS = array(0,100,0); else $_WIDTHS = array(0,100);
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array();
       $hits = $row->hits;
       if(!$total_hits) $percentage = 0; else $percentage = $hits/$total_hits*100;
       $link = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_NEWS."&newsID=$row->newsID&action=".WM3_cACTION_SHOW_SINGLE_NEWS;
	   if($allowed) $allowed_link = $base_allowed_link."&newsID=$row->newsID";
       array_push($_CONTENTS,"<nobr><a href=\"$link\">".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</a></nobr>");
       array_push($_CONTENTS,wm3Util::makePercentageBar($w3,$percentage,300,14)." ".round($percentage,2)."% ($hits)");
	   if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_NEWS,"action_edit.png",$w3->getWord(178)));
	   $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false,array(),false,false,true);
       $p++;
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public static function renderStatisticBaseDownload($w3,$label,$max_items=0)
    {
     // Get base downloads statistics list

     // Prepare variables to create the list
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DOWNLOADS); // Used to enable admin buttons
	 if($allowed) {
		           $columns = 3;
				   $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DOWNLOADS;
				  }
	 else         { $columns = 2; }

     // Do the query and take the total items number
	 $where = "WHERE ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.categoryID AND
                     ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_downloads.subcategoryID
                 AND ".WM3_cCONFIG_DB_PREFIX."_downloads.enabled * ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.enabled * ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.enabled = '".WM3_cENABLED."'";
     $row = mysql_fetch_object(wm3Sql::sqlQuery("SELECT SUM(hits) AS total_hits
                                                 FROM ".WM3_cCONFIG_DB_PREFIX."_downloads,
											      	  ".WM3_cCONFIG_DB_PREFIX."_downloads_categories,
												      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories
												 $where"));
     $total_hits = $row->total_hits;
     if($max_items) $limit = "LIMIT 0,$max_items"; else $limit = "";
     $rs = wm3Sql::sqlQuery("SELECT ".WM3_cCONFIG_DB_PREFIX."_downloads.*
                             FROM   ".WM3_cCONFIG_DB_PREFIX."_downloads,
							        ".WM3_cCONFIG_DB_PREFIX."_downloads_categories,
									".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories
							 $where
                             ORDER BY hits DESC
                             $limit");
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array();
     array_push($_CONTENTS,$w3->getWord($label));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
	 if($allowed) $_WIDTHS = array(0,100,0); else $_WIDTHS = array(0,100);
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array();
       $hits = $row->hits;
       if(!$total_hits) $percentage = 0; else $percentage = $hits/$total_hits*100;
	   if($allowed) $allowed_link = $base_allowed_link."&downloadID=$row->downloadID";
       array_push($_CONTENTS,"<nobr>$row->name</nobr>");
       array_push($_CONTENTS,wm3Util::makePercentageBar($w3,$percentage,300,14)." ".round($percentage,2)."% ($hits)");
	   if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_DOWNLOAD,"action_edit.png",$w3->getWord(178)));
	   $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false,array(),false,false,true);
       $p++;
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public static function renderStatisticBaseMiscellaneous($w3,$label)
    {
     // Get miscellaneous base statistics list

     // Prepare variables to create the list
     $columns = 2; $_WIDTHS = array(15,85);

     // Create list header
     $_CONTENTS = array();
     array_push($_CONTENTS,$w3->getWord($label));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

     // News
	 $_CONTENTS = array();
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWS); // Used to enable admin buttons
	 $title = wm3Util::renderImg("icon_news.png",'',32,32)." ".$w3->getWord(17);
	 if($allowed) {
		           $total = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_news');
                   $total_disabled = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_news',"WHERE enabled='".WM3_cDISABLED."'");
				   $total_enabled  = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_news',"WHERE enabled='".WM3_cENABLED."'");
				   $info = $total." ($total_disabled disabled, $total_enabled enabled)";
			      }
     else         {
		           $info = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_news',"WHERE enabled='".WM3_cENABLED."'");
		          }
     array_push($_CONTENTS,"<nobr>$title</nobr>",$info);
	 $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false,array(),false,false,true);

     // Users
     $_CONTENTS = array();
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_USERS); // Used to enable admin buttons
	 $title = wm3Util::renderImg("icon_users.png",'',32,32)." ".$w3->getWord(19);
	 if($allowed) {
	               $total               = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_users');
	               $total_standard      = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_users',"WHERE admin='".WM3_cDISABLED."'");
	               $total_administrator = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_users',"WHERE admin='".WM3_cENABLED."' AND superuser='".WM3_cDISABLED."'");
	               $total_superuser     = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_users',"WHERE superuser='".WM3_cENABLED."'");
				   $total_disabled      = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_users',"WHERE enabled='".WM3_cDISABLED."' OR deleted='".WM3_cENABLED."'");
				   $total_enabled       = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_users',"WHERE enabled='".WM3_cENABLED."' AND deleted='".WM3_cDISABLED."'");
	               $last_user = "Newest member: ";
				   $login = "login";//TODO
	               $last_user .= "<a href=\"xxx\">$login</a>";
				   $info = $total." ($total_standard standard, $total_administrator administrators, $total_superuser superuser) ($total_disabled disabled, $total_enabled enabled)<br>$last_user";
				  }
     else         {
	               $total               = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_users',"WHERE enabled='".WM3_cENABLED."' AND deleted='".WM3_cDISABLED."'");
	               $total_standard      = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_users',"WHERE admin='".WM3_cDISABLED."' AND enabled='".WM3_cENABLED."' AND deleted='".WM3_cDISABLED."'");
	               $total_administrator = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_users',"WHERE admin='".WM3_cENABLED."' AND enabled='".WM3_cENABLED."' AND deleted='".WM3_cDISABLED."'");
				   $info = $total." ($total_standard standard, $total_administrator administrators)";
			      }
     array_push($_CONTENTS,"<nobr>$title</nobr>",$info);
	 $str .= wm3Section::makeItemList($w3,1,$_WIDTHS,$_CONTENTS,false,array(),false,false,true);

     // Newsletter
     $_CONTENTS = array();
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWSLETTER); // Used to enable admin buttons
	 $title = wm3Util::renderImg("icon_newsletter.png",'',32,32)." ".$w3->getWord(11);
	 if($allowed) {
	               $total          = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_newsletters_items');
	               $total_disabled = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_newsletters_items',"WHERE enabled='".WM3_cDISABLED."'");
				   $total_enabled  = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_newsletters_items',"WHERE enabled='".WM3_cENABLED."'");
				   $info = $total." ($total_disabled disabled, $total_enabled enabled)";
			      }
     else         {
	               $info = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_newsletters_items',"WHERE enabled='".WM3_cENABLED."'");
		          }
     array_push($_CONTENTS,"<nobr>$title</nobr>",$info);
	 $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false,array(),false,false,true);

     // Search
     $_CONTENTS = array();
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_SEARCH_ENGINE); // Used to enable admin buttons
	 $title = wm3Util::renderImg("icon_searchengine.png",'',32,32)." ".$w3->getWord(13);
	 if($allowed) {
	               $total          = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_search_engines_items');
	               $total_disabled = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_search_engines_items',"WHERE enabled='".WM3_cDISABLED."'");
				   $total_enabled  = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_search_engines_items',"WHERE enabled='".WM3_cENABLED."'");
				   $info = $total." ($total_disabled disabled, $total_enabled enabled)";
		          }
	 else         {
		           $info = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_search_engines_items',"WHERE enabled='".WM3_cENABLED."'");
                  }
     array_push($_CONTENTS,"<nobr>$title</nobr>",$info);
	 $str .= wm3Section::makeItemList($w3,1,$_WIDTHS,$_CONTENTS,false,array(),false,false,true);

     // Links
     $_CONTENTS = array();
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_SEARCH_ENGINE); // Used to enable admin buttons
	 $title = wm3Util::renderImg("icon_links.png",'',32,32)." ".$w3->getWord(18);
	 if($allowed) {//TODO fare query considerando anche le categorie...
		           $total = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_links');
	               $total_disabled = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_links',"WHERE enabled='".WM3_cDISABLED."'");
				   $info = $total." (Disabled $total_disabled)????";
				  }
	 else         {
		           $info = "?";
		          }
     array_push($_CONTENTS,"<nobr>$title</nobr>",$info);
	 $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false,array(),false,false,true);

     // Signalations
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_STATISTICS); // Used to enable admin buttons
	 if($allowed)
	  {
	   $_CONTENTS = array();
	   $title = wm3Util::renderImg("icon_messages.png",'',32,32)." ".$w3->getWord(25);
	   $info  = wm3Preferences::loadTotalSignalations();
       array_push($_CONTENTS,"<nobr>$title</nobr>",$info);
	   $str .= wm3Section::makeItemList($w3,1,$_WIDTHS,$_CONTENTS,false,array(),false,false,true);
      }

/*
Site visitors: 3(0) //c'è gia in statistiche cronologiche
Number of items in the F.A.Q. section: 0
Number of items in the little market: 0
Number of banners in the database: 0
Number of horoscopes: 0
The banners are: OFF
*/

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public static function renderStatisticHistory($w3,$label,$type,$year = '',$month = '', $day = '', $no_link = false)
    {
     // Get history statistics range list

     // Prepare variables to create the list
	 $label = $w3->getWord($label);
	 $link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_STATISTICS."&action=".WM3_cACTION_SHOW_HISTORY_STATISTIC;
	 if($type == WM3_cSTATISTIC_YEARLY)        { $field = 'year';            $filter = "";														     $s = wm3Statistic::getMinYear(); $n = wm3Statistic::getMaxYear();                    $columns = $n - $s + 2; $_LABELS = array();                                       $array_offset = 1; $link .= "&yearID=";                                                                                                                                              }
	 if($type == WM3_cSTATISTIC_MONTHLY)       { $field = 'month';           $filter = "WHERE year = '$year'";                                       $s = 1;                          $n = 12;                                            $columns = $n + 1;      $_LABELS = $w3->getLanguageObj()->getArrayMonth();        $array_offset = 1; $link .= "&yearID=$year&monthID=";              $label .= " $year:";                                                                                              }
	 if($type == WM3_cSTATISTIC_DAILY)         { $field = 'day';             $filter = "WHERE year = '$year' AND month = '$month'"; 				 $s = 1;                          $n = cal_days_in_month(CAL_GREGORIAN,$month,$year); $columns = $n + 1;      $_LABELS = array();                                       $array_offset = 1; $link .= "&yearID=$year&monthID=$month&dayID="; $label .= " ".$w3->getWordMonth($month)." $year:";                                                                }
	 if($type == WM3_cSTATISTIC_HOURLY)        { $field = 'hour';            $filter = "WHERE year = '$year' AND month = '$month' AND day = '$day'"; $s = 0;                          $n = 23;                                            $columns = $n + 2;      $_LABELS = wm3Statistic::getArrayHour();                  $array_offset = 0;                                                 $label .= " ".wm3Util::renderDate($w3,mktime(0,0,0,$month,$day,$year),$w3->getAdminLanguage(),true,'',false).":"; }
	 if($type == WM3_cSTATISTIC_WEEKLY)        { $field = 'day_of_the_week'; $filter = ""; 														     $s = 1;                          $n = 7;                                             $columns = $n + 1;      $_LABELS = $w3->getLanguageObj()->getArrayDayOfTheWeek(); $array_offset = 1;                                                                                                                                                                   }
	 if($type == WM3_cSTATISTIC_HOURLY_GLOBAL) { $field = 'hour';            $filter = "";                                                           $s = 0;                          $n = 23;                                            $columns = $n + 2;      $_LABELS = wm3Statistic::getArrayHour();                  $array_offset = 0;                                                                                                                                                                   }

     // Do the query and take the total items number
	 $total_hits = wm3Statistic::getTotalVisits();
     $rs = wm3Sql::sqlQuery("SELECT SUM(hits) AS hits,$field
	                         FROM   ".WM3_cCONFIG_DB_PREFIX."_statistics_history
							 $filter
							 GROUP BY $field
							 ORDER BY $field");
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array();
     array_push($_CONTENTS,$label);
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
	 $_CONTENTS_TOP  = $_CONTENTS = $_CONTENTS_BOTTOM = $_WIDTHS = array();
	 $row = mysql_fetch_array($rs);
	 
	 $max_percentage = 0;
	 
	 //for($i = $s; $i <= $n; $i++)
	 // {
	   //$current_percentage = round($percentage,2)
	   //if() $max_percentage = print_r($row);
     // }
	 
     for($i = $s; $i <= $n; $i++)
	  {
       if($row[$field] == $i)
        {
         $hits = $row['hits'];
		 $row  = mysql_fetch_array($rs);
	    }
	   else $hits = 0;
	   if(!$total_hits) $percentage = 0; else $percentage = $hits/$total_hits*100;
	   if(!$no_link) { $a_open = "<a href=\"$link$i\">"; $a_close = "</a>"; } else { $a_open = $a_close = ""; }
       if($_LABELS) array_push($_CONTENTS_TOP,$a_open.$_LABELS[$i-$array_offset].$a_close);
	   else         array_push($_CONTENTS_TOP,$a_open.$i.$a_close);//$row[$field]);
       array_push($_CONTENTS,wm3Util::makePercentageBar($w3,$percentage,12,180,false));
	   array_push($_CONTENTS_BOTTOM,round($percentage,2)."%<br>($hits)");
	   array_push($_WIDTHS,0);
	  }

     array_push($_CONTENTS_TOP,'');
	 array_push($_CONTENTS,'');
	 array_push($_CONTENTS_BOTTOM,'');
	 array_push($_WIDTHS,100);
     $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS_TOP,false,array(),false,true);
	 $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false,array(),false,true);
	 $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS_BOTTOM,false,array(),false,true);

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public static function renderStatisticTrend($w3,$label,$title,$start_day,$start_month,$start_year,$start_hour,$end_day,$end_month,$end_year,$end_hour,$step,$zoom)
    {
     // Get statistics trends list

     // Prepare variables to create the list
	 $start_ts = strtotime("$start_day-$start_month-$start_year $start_hour:00");
	 $end_ts   = strtotime("$end_day-$end_month-$end_year $end_hour:00");
     if($step == WM3_cSTATISTIC_TREND_STEP_HOUR)
	  {
	   $field = 'hour'; $filter = "";
	   $n = ($end_ts - $start_ts) / 60 / 60;
	  }
	 else
	  {
	   $field = 'day';  $filter = "";
	   $n = ($end_ts - $start_ts) / 60 / 60 / 24;
	  }
	 $columns = $n + 1;

     // Do the query and take the total items number
     $total_hits = wm3Statistic::getTotalVisits();
     $rs = wm3Sql::sqlQuery("SELECT SUM(hits) AS hits,$field
	                         FROM   ".WM3_cCONFIG_DB_PREFIX."_statistics_history
							 $filter
							 GROUP BY $field
							 ORDER BY $field");
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array();
	 $search_form_link = WM3_cCONFIG_ADMIN_FILE;
	 require(WM3_cPATH_INCLUDE."admin_statistic_trend_search_form.inc");
     array_push($_CONTENTS,$w3->getWord($label));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,1,$search_form);

     // Create list caption
	 $str .= wm3Section::makeItemList($w3,1,array(100),array($title),false);
	 //$str .= wm3Section::makeCaptionList($w3,array(100),array(373),1,true);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,1,593);

     // Create list items
	 $_CONTENTS = $_CONTENTS_BOTTOM = $_WIDTHS = array(); $histogram = '';
	 $row = mysql_fetch_array($rs);
     for($i = 1; $i <= $n; $i++)
	  {
       if($row[$field] == $i)
        {
         $hits = $row['hits'];
		 $row = mysql_fetch_array($rs);
	    }
	   else $hits = 0;
	   if(!$total_hits) $percentage = 0; else $percentage = $hits/$total_hits*100;
	   $alt = round($percentage,2)."% ($hits)";
       array_push($_CONTENTS,wm3Util::makePercentageBar($w3,$percentage,1*$zoom,100*$zoom,false,$alt));
	   array_push($_CONTENTS_BOTTOM,'');
	   array_push($_WIDTHS,0);
	  }
	 array_push($_CONTENTS,'');
	 array_push($_CONTENTS_BOTTOM,'');
	 array_push($_WIDTHS,100);
	 $histogram .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false,array(),false,true);
	 $histogram .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS_BOTTOM,false,array(),false,true);
     $str .= wm3Section::makeItemList($w3,0,array(100),array(wm3Section::makeHeaderList($w3,array(),0).$histogram.wm3Section::makeBottomList($w3,1)),false);

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,1);

     return $str;
    }

   public static function updateStatisticBrowser()
    {
     // Update statistics for the browsers
	 $user_agent = getenv('HTTP_USER_AGENT');
     if    (eregi("bot",       $user_agent)   ||
	        ereg ("Google",    $user_agent)   ||
			ereg ("Slurp",     $user_agent)   ||
			ereg ("Scooter",   $user_agent)   ||
			eregi("Spider",    $user_agent)   ||
			eregi("Infoseek",  $user_agent))  $browser = WM3_cBROWSER_SEARCH_ENGINE;
     elseif((ereg ("Nav",       $user_agent)  ||
	        ereg ("Gold",      $user_agent)   ||
			ereg ("X11",       $user_agent)   ||
			ereg ("Netscape",  $user_agent))  &&
			(!ereg ("Mozilla",   $user_agent) &&
			!ereg("MSIE",      $user_agent)   &&
			!ereg("Konqueror", $user_agent))) $browser = WM3_cBROWSER_NETSCAPE;
     elseif(ereg ("MSIE",      $user_agent))  $browser = WM3_cBROWSER_IE;
	 elseif(ereg ("Chrome",   $user_agent))   $browser = WM3_cBROWSER_CHROME;
	 elseif(ereg ("Mozilla",   $user_agent))  $browser = WM3_cBROWSER_MOZILLA;
     elseif(ereg ("Lynx",      $user_agent))  $browser = WM3_cBROWSER_LYNX;
     elseif(ereg ("Opera",     $user_agent))  $browser = WM3_cBROWSER_OPERA;
     elseif(ereg ("WebTV",     $user_agent))  $browser = WM3_cBROWSER_WEBTV;
     elseif(ereg ("Konqueror", $user_agent))  $browser = WM3_cBROWSER_KONQUEROR;
     elseif(ereg ("IBrowse",   $user_agent))  $browser = WM3_cBROWSER_IBROWSE;
     else                                     $browser = WM3_cBROWSER_OTHER;
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_statistics_browsers SET hits = hits + 1 WHERE  browserID = '$browser'");
    }

   public static function updateStatisticOS()
    {
     // Update statistics for OSes
	 $user_agent = getenv('HTTP_USER_AGENT');
	 if    (ereg("Mac",    $user_agent)  ||
	        ereg("PPC",    $user_agent)) $os = WM3_cOS_MACOS;
     elseif(ereg("Win",    $user_agent)) $os = WM3_cOS_WINDOWS;
     elseif(ereg("Linux",  $user_agent)) $os = WM3_cOS_LINUX;
     elseif(ereg("FreeBSD",$user_agent)) $os = WM3_cOS_FREEBSD; //TODO controllare
     elseif(ereg("SunOS",  $user_agent)) $os = WM3_cOS_SUNOS;
     elseif(ereg("IRIX",   $user_agent)) $os = WM3_cOS_IRIX; //TODO controllare
     elseif(ereg("BeOS",   $user_agent)) $os = WM3_cOS_BEOS;
     elseif(ereg("OS/2",   $user_agent)) $os = WM3_cOS_OS2; //TODO controllare
     elseif(ereg("AIX",    $user_agent)) $os = WM3_cOS_AIX;
     elseif(ereg("Amiga",  $user_agent)) $os = WM3_cOS_AMIGAOS;
     else                                $os = WM3_cOS_OTHER;
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_statistics_oses SET hits = hits + 1 WHERE osID = '$os'");
    }

   function updateStatisticCountry()
    {
     $hostname = gethostbyaddr(getenv('REMOTE_ADDR'));
     $code     = strtolower(substr(strrchr($hostname,'.'),1));
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_countries SET hits = hits + 1 WHERE code = '$code'");
    }

   public static function updateStatisticHistory()
    {
     // Update statistics history
	 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_statistics_history WRITE");
	 $_FIELD = webmatic3::getPostValueArray(wm3Statistic::getStatisticHistoryFieldsArray());
     $ts = time();
	 $_FIELD['year']            = date('Y',$ts);
	 $_FIELD['month']           = date('n',$ts);
	 $_FIELD['day']             = date('j',$ts);
	 $_FIELD['hour']            = date('G',$ts);
	 $_FIELD['day_of_the_week'] = date('N',$ts);
	 $_FIELD['hits']            = 1;
	 $_FIELD['ts']              = $ts;
     $rs = wm3Sql::sqlQuery("SELECT historyID FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history WHERE year = '".$_FIELD['year']."' AND month = '".$_FIELD['month']."' AND day = '".$_FIELD['day']."' AND hour = '".$_FIELD['hour']."' AND day_of_the_week = '".$_FIELD['day_of_the_week']."'");
	 if(mysql_num_rows($rs) == 0) {
	                               wm3Sql::saveAllTableFields('_statistics_history',$_FIELD);
                                  }
	 else                         {
		                           $row = mysql_fetch_object($rs);
	                               wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_statistics_history
                                                        SET hits = hits + 1
                                                      WHERE historyID = '$row->historyID'");
								  }
     wm3Sql::sqlQuery("UNLOCK TABLES");
    }

   public static function getCountryFlag($countryID)
    {
     $rs = wm3Sql::sqlQuery("SELECT code FROM ".WM3_cCONFIG_DB_PREFIX."_countries
                             WHERE countryID = '$countryID'");
     if(mysql_num_rows($rs) != 1) return "_unknown.gif";
     $row = mysql_fetch_object($rs);
     return $row->code.".gif";
    }

   public static function getCountryName($w3,$countryID)
    {
     $rs = wm3Sql::sqlQuery("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_countries
                             WHERE countryID = '$countryID'");
     if(mysql_num_rows($rs) != 1) return $w3->getWord(1139);
     $row = mysql_fetch_object($rs);
     return $row->name;
    }

   public static function getArrayHour($separator = '<br>')
    {
	 $_ARRAY = array();
	 for($i = 0;  $i <= 9;  $i++) array_push($_ARRAY,"0".$i.":00".$separator."0".$i.":59");
	 for($i = 10; $i <= 23; $i++) array_push($_ARRAY,$i.":00".$separator.$i.":59");
	 return $_ARRAY;
	}

   public static function getMaxYear()
    {
     $rs = wm3Sql::sqlQuery("SELECT MAX(year) AS max FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history");
     if(mysql_num_rows($rs) != 1) return "";
     $row = mysql_fetch_object($rs);
     return $row->max;
    }

   public static function getMinYear()
    {
     $rs = wm3Sql::sqlQuery("SELECT MIN(year) AS min FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history");
     if(mysql_num_rows($rs) != 1) return "";
     $row = mysql_fetch_object($rs);
     return $row->min;
    }

   public static function getTotalVisits()
    {
     $row = mysql_fetch_object(wm3Sql::sqlQuery("SELECT SUM(hits) AS total FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history"));
     if($row->total) return $row->total; else return 0;
    }

   public static function getTodayVisits()
    {
	 $ts = time();
	 $year = date('Y',$ts); $month = date('n',$ts); $day = date('j',$ts);
     $rs = wm3Sql::sqlQuery("SELECT SUM(hits) AS total
	                           FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history
							  WHERE day = '$day' AND month = '$month' AND year = '$year'");
     $row = mysql_fetch_object($rs);
     if($row->total) return $row->total; else return 0;
    }

   public static function getCounterMaxVisitors()
    {
     $rs = wm3Sql::sqlQuery("SELECT max_visitors FROM ".WM3_cCONFIG_DB_PREFIX."_counters");
     if(mysql_num_rows($rs) != 1) return 0;
     $row = mysql_fetch_object($rs);
     return $row->max_visitors;
    }

   public static function getCounterMaxUsers()
    {
     $rs = wm3Sql::sqlQuery("SELECT max_users FROM ".WM3_cCONFIG_DB_PREFIX."_counters");
     if(mysql_num_rows($rs) != 1) return 0;
     $row = mysql_fetch_object($rs);
     return $row->max_users;
    }

   public static function getCounterLastUserIp()
    {
     $rs = wm3Sql::sqlQuery("SELECT last_user_ip FROM ".WM3_cCONFIG_DB_PREFIX."_counters");
     if(mysql_num_rows($rs) != 1) return '';
     $row = mysql_fetch_object($rs);
     return $row->last_user_ip;
    }

   public static function getCounterLastUserDns()
    {
     $rs = wm3Sql::sqlQuery("SELECT last_user_dns FROM ".WM3_cCONFIG_DB_PREFIX."_counters");
     if(mysql_num_rows($rs) != 1) return '';
     $row = mysql_fetch_object($rs);
     return $row->last_user_dns;
    }

   public static function getCounterLastUserID()
    {
     $rs = wm3Sql::sqlQuery("SELECT last_userID FROM ".WM3_cCONFIG_DB_PREFIX."_counters");
     if(mysql_num_rows($rs) != 1) return 0;
     $row = mysql_fetch_object($rs);
     return $row->last_userID;
    }

   public static function getCounterLastUserTs()
    {
     $rs = wm3Sql::sqlQuery("SELECT last_user_ts FROM ".WM3_cCONFIG_DB_PREFIX."_counters");
     if(mysql_num_rows($rs) != 1) return 0;
     $row = mysql_fetch_object($rs);
     return $row->last_user_ts;
    }

   public static function resetStatisticAll()
    {
	 // Reset all statistics and users ratings
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_statistics_browsers SET hits = 0");
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_statistics_oses     SET hits = 0");
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_countries           SET hits = 0");
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages               SET hits = 0");
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_news                SET hits = 0");//TODO resettare anche votes_counts,votes_sum e votes_average quando saranno presenti, in futuro, anche nella tabella _news
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads           SET hits = 0");
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items   SET hits = 0, votes_counts = 0, votes_sum = 0, votes_average = 0");
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items  SET hits = 0, votes_counts = 0, votes_sum = 0, votes_average = 0");
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_counters
	                      SET total_visitors     = 0,
						      total_signalations = 0,
							  max_visitors       = 0,
							  max_users          = 0,
							  last_user_ip       = '',
							  last_user_dns      = '',
							  last_userID 	     = 0,
							  last_user_ts       = 0");
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history");
	}

   public static function selectStatisticHour($w3,$name,$hour,$js = "")
    {
     // Make statistic hours select
     return wm3Util::selectArray($name,
                        wm3Statistic::getArrayHour('-'),
                        array('0','1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','19','20','21','22','23'),
                        $hour,
                        $js);
    }

   public static function selectStatisticStep($w3,$name,$step,$js = "")
    {
     // Make statistic step select
     return wm3Util::selectArray($name,
                        array($w3->getWord(960),$w3->getWord(961)),
                        array(WM3_cSTATISTIC_TREND_STEP_HOUR,WM3_cSTATISTIC_TREND_STEP_DAY),
                        $step,
                        $js);
    }

   public static function selectStatisticZoom($w3,$name,$zoom,$js = "")
    {
     // Make statistic zoom select
     return wm3Util::selectArray($name,
                        array('x1','x2','x3','x4'),
                        array('1','2','3','4'),
                        $zoom,
                        $js);
    }

   public static function getWebmaticInformations($w3)
    {
     // Get Informations and credits about webmatic (admin side)

     // Prepare variables to create the list
     $columns = 2; $buttons = 0;

     // Do the query and take the total items number

     // Create list header
     $_CONTENTS = array();
     array_push($_CONTENTS,$w3->getWord(-1)."Webmatic informations");
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)

     // Create list items
     $_WIDTHS = array(30,70);
     $_CONTENTS = array(); $label = "Webmatic version";
	 array_push($_CONTENTS,$label,WM3_cVERSION);
     $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false);

	 $_CONTENTS = array(); $label = "Webmatic database version";
     array_push($_CONTENTS,$label,WM3_cDB_VERSION." (".wm3Sql::countDBTables()." tables)");
     $str .= wm3Section::makeItemList($w3,1,$_WIDTHS,$_CONTENTS,false);

	 $_CONTENTS = array(); $label = "Webmatic database used space";
	 $size = wm3Folder::renderFileSize($w3,wm3Sql::countDBUsedSpace($w3));
     array_push($_CONTENTS,$label,$size);
     $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false);

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
	}

  }

?>
